/*
 * Copyright 2010 University of Chicago/Argonne National Laboratory
 *
 * @author Neill Miller
 */

#define MAX_UUID_LEN       32
#define MAX_ACTION_LEN     32
#define MAX_RESOURCE_LEN 1024

#define ADQ_PERMIT          0
#define ADQ_DENY            1
#define ADQ_INDETERMINATE   2

#define ADQ_FREE(x)          \
do {                         \
if (x) {free(x); x = NULL; } \
} while(0)

typedef struct
{
    int decision;
    char action[MAX_ACTION_LEN];
    char resource[MAX_RESOURCE_LEN];
} authz_decision_t;

int get_authorization_decision(
    char *service_endpoint, char *openid, char *resource, char *action,
    authz_decision_t *authz_out_p);
